
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
from gameobjectmagicuser import *
from deepgnomeillusionistspelldictionary1 import *

import random
from time import *

class DeepGnomeIllusionist1(Gameobject, GameobjectMagicUser):
    ""
    def __init__(self,xx,yy,game):
	Gameobject.__init__(self, xx, yy)
	GameobjectMagicUser.__init__(self, self.rng, self.rng.rolld400(), ["Mass Dream"], DeepGnomeIllusionistSpellDictionary1(game, self))
        self.w = 48 
        self.h = 48 
        self.image = pygame.image.load('./pics/deepgnome1-48x48.bmp').convert()
        self.image.set_colorkey((0,0,255)) 
        self.talkcounter = 0
	self.hitpoints = 100000
        
    def draw(self, screen, room):
        screen.blit(self.image, (self.x+room.relativex,self.y+room.relativey))
	     
    def update(self,room,player):
	self.cast(room,player)

    def collide(self, room, player):
	if (player.x > self.x+room.relativex  and 
	player.x < self.x+room.relativex+self.w and 
	player.y > self.y+room.relativey and 
	player.y < self.y+room.relativey + self.h):
	    print "collision with deepgnome1!"
	    return 1 
	else:
	    return 0
		 
    def collidetalk(self, room, player):
	if (player.x > self.x+room.relativex-self.w  and 
	player.x < self.x+room.relativex+self.w and 
	player.y > self.y+room.relativey-self.h and 
	player.y < self.y+room.relativey + self.h):
	    print "collision talk with deepgnome1!"
	    return 1 
	else:
	    return 0
		 
    def talk(self, game):
	return self

    def drawtalk(self,screen,font):
    	screen.blit(font.render("Hello.", 6, (255,255,255)), (10,300))	
