
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from random import *

from deitybase import *

class Deity(DeityBase):
    "Random Number God Subclass for deity powers granted to player"
    def __init__(self, game):
        DeityBase.__init__(self) 
	self.game = game
	self.enhancedpowerbydeity = 0.0
	self.deityalignment = "True Neutral" 
	self.deityhonor = 110 
	self.deitydomainnumbers = dict()

	self.deityfunctions = dict()
	# NOTE does not start from 0 to roll
	self.deityfunctions[0] = self.doesnothing 
	self.deityfunctions[1] = self.doesnothing 
	self.deityfunctions[2] = self.doesnothing 
	self.deityfunctions[3] = self.doesnothing 
	self.deityfunctions[4] = self.doesnothing 
	self.deityfunctions[5] = self.doesnothing 
	self.deityfunctions[6] = self.doesnothing 
	self.deityfunctions[7] = self.doesnothing 
	self.deityfunctions[8] = self.doesnothing 
	self.deityfunctions[9] = self.doesnothing 
	self.deityfunctions[10] = self.doesnothing 
	self.deityfunctions[11] = self.doesnothing 
	self.deityfunctions[12] = self.doesnothing 
	self.deityfunctions[13] = self.doesnothing 
	self.deityfunctions[14] = self.doesnothing 
	self.deityfunctions[15] = self.doesnothing 
	self.deityfunctions[16] = self.doesnothing 
	self.deityfunctions[17] = self.doesnothing 
	self.deityfunctions[18] = self.doesnothing 
	self.deityfunctions[19] = self.doesnothing 
	self.deityfunctions[20] = self.doesnothing 

	self.neutralminimumlimit = -40.0
	self.neutralmaximumlimit = +40.0

	self.domains = dict() 
	self.attractedenemies = dict()
	self.lowerlifeforms = dict()
	
    def attention(self, enemy, goidx):
	prevlowerlifeforms = self.lowerlifeforms 
	self.lowerlifeforms = []

	align = self.deityalignment.split(" ",1)[0]
	align2 = self.deityalignment.split(" ",1)[1]
	if align == "Good" or align2 == "Good": 
		if enemy.type < 0:
			self.lowerlifeforms[goidx] = enemy
			###if goidx in prevlowerlifeforms.keys():
			###	enemy.alterlikedbygod(-1)
	
	elif align == "Evil" or align2 == "Evil": 
		if enemy.type > 0:
			self.lowerlifeforms[goidx] = enemy
			###if goidx in prevlowerlifeforms.keys():
			###	enemy.alterlikedbygod(+1)

    def doesnothing(self):
	1

    def doesmore(self):
	return self.rolld2()

    def deitygrantrandompriestspellbasedonlevel(self, game):
	align = self.deityalignment.split(" ",1)[0]
	align2 = self.deityalignment.split(" ",1)[1]

	print "align=%s align2=%s" % (align, align2)
	print "defeated enemies n=%d player priestlevel=%d" % (game.player.deityenemydefeatedpoints, game.player.priestlevel)
	if align == "Good" or align2 == "Good": 
		if game.player.priestlevel > 0:
			if game.player.deityenemydefeatedpoints < -40:
				for i in self.domains.keys():
					if self.rolld4() == 1:
						r = self.getrng().rollbetween(1,len(self.domains[i].spells.keys()))
						if game.player.priestlevel == 1:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 2:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 3:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 4:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 5:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 6:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 7:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 8:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 9:
							return self.domains[i].spells[r]
						else:
							return self.domains[i].spells[r]	
	if align == "Neutral" or align2 == "Neutral": 
		if game.player.priestlevel > 0:
			if game.player.deityenemydefeatedpoints < self.neutralmaximumlimit and game.player.deityenemydefeatedpoints > self.neutralminimumlimit:
				for i in self.domains.keys():
					if self.rolld4() == 1:
						r = self.getrng().rollbetween(1,len(self.domains[i].spells))
						if game.player.priestlevel == 1:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 2:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 3:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 4:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 5:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 6:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 7:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 8:
							return self.domains[i].spells[r]
						elif game.player.priestlevel == 9:
							return self.domains[i].spells[r]
						else:
							return self.domains[i].spells[r]	
	return None

    def deitywatches(self, rollslist, game):
	leveln = game.player.priestlevel
	r = self.rng.rolld100()
	if r == 1 and game.player.luck.get() % self.rng.rollbetween(1,self.deityhonor) > 10:
		for el in rollslist:
			if el in self.deityfunctions.keys():
				self.deityfunctions[el]()
				if self.doesmore() and leveln > 0:
					leveln -= 1
				else:
					return 0 

    def rollgodd20(self):
	r = DeityBase.rolld20()
	self.deityfunctions[r]()

   ### NOTE :
   ### for natural rolling use RNG or DietyBase.rolld20 etc

    def rolld400(self):
        return (randint(1,400) + self.enhancedpowerbydeity)

    def rolld200(self):
        return (randint(1,200) + self.enhancedpowerbydeity)

    def rolld100(self):
        return (randint(1,100) + self.enhancedpowerbydeity)

    def rolld50(self):
        return (randint(1,50) + self.enhancedpowerbydeity)

    def rolld40(self):
        return (randint(1,40) + self.enhancedpowerbydeity)

    def rolld20(self):
        return (randint(1,20) + self.enhancedpowerbydeity)

    def rolld10(self):
        return (randint(1,10) + self.enhancedpowerbydeity)

    def rolld6(self):
        return (randint(1,6) + self.enhancedpowerbydeity)

    def rolld4(self):
        return (randint(1,4) + self.enhancedpowerbydeity)

    def rolld2(self):
        return (randint(1,2) + self.enhancedpowerbydeity)

    
