
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from random import *

from deity import *
from gooddomain import *
from wildernessdomain import *

class DeityCorellonLarethain(Deity):
    "Random Number God Subclass for deity powers granted to player"
    def __init__(self,game):
        Deity.__init__(self, game)
	self.deityalignment = "Chaotic Good"
	if game.player.askrace() == "Elf":
		self.enhancedpowerbydiety = self.rolld2()
		self.deityhonor = 102
		self.domains["Wilderness"] = WildernessDomain(self)
		self.domains["Good"] = GoodDomain(self)
		self.deitydomainnumbers[0] = "Wilderness"
		self.deitydomainnumbers[1] = "Good"
		if game.player.askclass() == "Magic User":
			self.enhancedpowerbydiety = self.rolld3()
			game.player.maxmanapoints += 10
			game.player.manapoints += 10
	elif game.player.askrace() != "Elf":
		self.deityhonor = 112
		self.enhancedpowerbydiety = self.rolld2()
		self.domains["Good"] = GoodDomain(self)
		self.deitydomainnumbers[0] = "Good"
					
 
	self.deityfunctions = dict()

	# NOTE does not start from 0 to roll
	self.deityfunctions[0] = self.doesnothing 
	self.deityfunctions[1] = self.doesenhancepower
	self.deityfunctions[2] = self.doesnothing 
	self.deityfunctions[3] = self.doesnothing 
	self.deityfunctions[4] = self.doesnothing 
	self.deityfunctions[5] = self.doesnothing 
	self.deityfunctions[6] = self.doesheal
	self.deityfunctions[7] = self.doesnothing 
	self.deityfunctions[8] = self.doesnothing 
	self.deityfunctions[9] = self.doesnothing 
	self.deityfunctions[10] = self.doesgivebonk
	self.deityfunctions[11] = self.doesnothing 
	self.deityfunctions[12] = self.doesnothing 
	self.deityfunctions[13] = self.doesnothing 
	self.deityfunctions[14] = self.doesnothing 
	self.deityfunctions[15] = self.doesnothing 
	self.deityfunctions[16] = self.doesnothing 
	self.deityfunctions[17] = self.doesnothing 
	self.deityfunctions[18] = self.doesnothing 
	self.deityfunctions[19] = self.doesnothing 
	self.deityfunctions[20] = self.doesnothing 
	
	self.game = game	

    def doesenhancepower(self):
	self.enhancedpowerbydeity += 1

    def doesgivebonk(self):
	for go in self.game.room.gameobjects:
		go.hitpoints -= 10

    def doesheal(self):
	game.player.hitpoints += self.rng.rolld40()
