
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from rng import *
from overalldeity import *
from wisdom import *
from communicate import *
from magic import *
from luck import *

class GameobjectPriest:
    "Game object"
    def __init__(self, rng, priestlevel, spellkeys, spelldictionary, deities, game):
	self.rng = rng
	self.wisdom = Wisdom(self.rng.rolld10() + 10)
	self.communicate = Communicate(self.rng.rolld100() + 100)
	self.luck = Luck(self.rng.rolld100()+100)
	self.honor = Honor(self.rng.rolld100()+100)
	if deities:
		self.deities = deities
	else:
		self.deities.append(OverallDiety(game))
	if not priestlevel:
		self.priestlevel = self.rng.rolld10()
	else:
		self.priestlevel = priestlevel
	self.priestspells = dict()

	for k in spellkeys:
		if k:
			self.priestspells[k] = spelldictionary.dict[k]

    def castpriestpower(self, room, player):
	castp = self.rng.rolld20()
	# roll below wisdom
	if castp > self.wisdom.get():
		return
	if self.luck.get() % self.rng.rollbetween(1,5) <= 2 and self.communicate.get() % 100 <= self.rng.rollbetween(1,50):

		deitychoice = self.rng.rollbetween(0, len(self.deities))
		j = 0
		for d in self.deities:
			if j == deitychoice:
				if self.honor.get() + self.rng.rolld100() > d.deityhonor:
					spellchoice = self.rng.rollbetween(0, len(self.priestspells.keys())) - 1
					i = 0
					for k in self.priestspells.keys():
						if i == spellchoice:
							self.priestspells[k]()	
							break	
						i += 1	
				j += 1 
			
