
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from rng import *
from intelligence import *
from spelldictionaryenemy import *
from magicmissileenemy1 import *
from magicmissileenemy2 import *
from magicmissileenemy3 import *
from fireballenemy1 import *

from abeilleenemy1 import *
from abeillequeenenemy import *
from hobgoblin1 import *
from goblin4 import *
from koboldwizard1 import *

class InvokerSpellDictionaryEnemy(SpellDictionaryEnemy):
    ""
    def __init__(self, game, enemy):
	SpellDictionaryEnemy.__init__(self, game, enemy)
	self.dict["Magic Missile 1"] = self.magicmissile1 
	self.dict["Magic Missile 2"] = self.magicmissile2 
	self.dict["Magic Missile 3"] = self.magicmissile3 
	self.dict["Fireball 1"] = self.fireball1 
	self.dict["Fireball 2"] = self.fireball2 
	self.dict["Fireball 3"] = self.fireball3 
	self.dict["Summon Good Monster 1"] = self.summongoodmonster1
	self.dict["Summon Evil Monster 1"] = self.summonevilmonster1

    def magicmissile1(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(MagicMissileEnemy1(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.addto(-1)

    def magicmissile2(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(MagicMissileEnemy2(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.addto(-2)

    def magicmissile3(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(MagicMissileEnemy3(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.addto(-3)

    def fireball1(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(FireballEnemy1(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.set(self.enemy.magic.get() - 1)

    def fireball2(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(FireballEnemy2(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.set(self.enemy.magic.get() - 1)

    def fireball3(self):
	if self.enemy.magic.get() <= 0:
		return

	self.game.room.gameobjects.append(FireballEnemy3(self.enemy.x+self.enemy.w,self.enemy.y+self.enemy.h/2,self.game.player.x,self.game.player.y,self.game.player))
	self.enemy.magic.set(self.enemy.magic.get() - 1)

    def summongoodmonster1(self):
	if self.enemy.magic.get() <= 0:
		return
	
	r = self.rng.rolld4()
	if r == 1:
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
	if r == 2:
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
	if r == 3:
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
	if r == 4:
		self.game.room.gameobjects.append(AbeilleQueen(self.enemy.x, self.enemy.y))	
	else:
		self.game.room.gameobjects.append(AbeilleEnemy1(self.enemy.x, self.enemy.y))	
		
	self.enemy.magic.set(self.enemy.magic.get() - 10)

    def summonevilmonster1(self):
	if self.enemy.magic.get() <= 0:
		return
	
	r = self.rng.rolld4()
	if r == 1:
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
	if r == 2:
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
	if r == 3:
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
		self.game.room.gameobjects.append(HobGoblin1(self.enemy.x, self.enemy.y))	
	if r == 4:
		self.game.room.gameobjects.append(KoboldWizard1(self.enemy.x, self.enemy.y, self.game))	
	else:
		self.game.room.gameobjects.append(Goblin4(self.enemy.x, self.enemy.y))	
		
	self.enemy.magic.set(self.enemy.magic.get() - 10)

