
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from dungeonkey1 import *
from dungeonmasterkey import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from tilebox import *
from rope import *
#from snake1 import *
from dungeondoor1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from scorpionred1 import *
from scorpionred2 import *
from scorpionred3 import *
from scorpionred4 import *
from skeleton1 import *
from skeleton2 import *
from skeleton3 import *
from spider1 import *
from spider2 import *
from cavespider1 import *
from cavespider2 import *
from roadsign import *
from movingplatform import *
from movingplatform2 import *
from chest1 import *
from healingpotion import *
from bow1 import *
from knightfighting import *
from ghostcircling import *
from ghostcircling2 import *
from ghostwandering import *

class Maproom2_1(MaproomDungeon):
    "Room with a (big) map - Dragonback Mountains room 1"
    def __init__(self,x,y):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg3-4000x1500.bmp").convert()
        ###self.northwall1 = Tilebox(1,1,60,48,16,1,'./pics/walldungeonnorth2-beholderglass-60x48.bmp')
##        self.northwall1 = Tilebox(1,1,60,48,13,1,'./pics/walldungeonnorth1-60x48.bmp')
##        self.southwall1 = Tilebox(1,200,30,48,13,1,'./pics/walldungeonsouth1-30x48.bmp')
##        self.westwall1 = Tilebox(360,255,48,60,1,10,'./pics/walldungeonwest1-48x60.bmp')
##        self.eastwall1 = Tilebox(775,1,48,60,1,14,'./pics/walldungeoneast1-48x60.bmp')
##        self.tileboxes.append(self.northwall1)
##        self.tileboxes.append(self.westwall1)
##        self.tileboxes.append(self.eastwall1)
##        self.tileboxes.append(self.southwall1)
        self.h = -1150
        

        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
        
        #self.gameobjects.append(GhostCircling2(100,250))
        self.gameobjects.append(GhostWandering(100,250))

        self.gameobjects.append(Skeleton3(1000,450,Box(1000,400,1000,400)))

        self.gameobjects.append(Skeleton3(1000,270,Box(900,0,1000,400)))
        self.gameobjects.append(Skeleton3(1000,270,Box(1000,0,1000,400)))
        self.gameobjects.append(Skeleton3(1100,270,Box(1100,0,1000,400)))
        self.gameobjects.append(Skeleton3(1260,270,Box(1205,0,1000,400)))
        self.gameobjects.append(Skeleton3(1300,270,Box(1300,0,1000,400)))
        self.gameobjects.append(Skeleton3(1400,270,Box(1400,0,1000,400)))
        self.gameobjects.append(Skeleton3(1500,270,Box(1500,0,1000,400)))

        self.gameobjects.append(Skeleton3(1000,270,Box(900,0,100,400)))
        self.gameobjects.append(Skeleton3(1100,270,Box(1000,0,100,400)))
        self.gameobjects.append(Skeleton3(1500,270,Box(1400,0,100,400)))
        self.gameobjects.append(Skeleton3(1600,270,Box(1500,0,100,400)))
        
        self.gameobjects.append(Skeleton3(2000,500,Box(2000,400,100,300)))
        self.gameobjects.append(Skeleton3(2500,500,Box(2500,400,100,300)))
        self.gameobjects.append(Skeleton3(2600,500,Box(2600,400,100,300)))
        self.gameobjects.append(Skeleton3(2700,500,Box(2700,400,100,300)))
        self.gameobjects.append(Skeleton3(3300,500,Box(3200,300,400,400)))
        self.gameobjects.append(Skeleton3(3320,500,Box(3220,300,400,400)))
        self.gameobjects.append(Skeleton3(3500,500,Box(3400,300,400,400)))
        self.gameobjects.append(Skeleton3(3700,500,Box(3600,300,400,400)))
        self.gameobjects.append(Skeleton3(3800,500,Box(3700,300,400,400)))
        self.gameobjects.append(Skeleton3(3900,500,Box(3800,300,400,400)))
        
        self.gameobjects.append(Spider2(3200,500))
        self.gameobjects.append(Spider2(2400,720))
        self.gameobjects.append(Spider1(1500,300))
        self.gameobjects.append(Spider1(1400,300))
        self.gameobjects.append(Spider1(500,300))
        self.gameobjects.append(Spider1(200,250))
        self.gameobjects.append(KnightFighting(1400,250))
        self.gameobjects.append(KnightFighting(3200,250))
        self.gameobjects.append(Spider2(1800,300))
        self.gameobjects.append(Spider2(1700,300))
        self.gameobjects.append(CaveSpider1(150,90))
        self.gameobjects.append(CaveSpider1(200,90))
    
        self.gameobjects.append(Spider1(3200,300))
        self.gameobjects.append(Spider1(3800,300))

        self.gameobjects.append(CaveSpider2(3050,90))
        self.gameobjects.append(CaveSpider2(3000,90))

        self.gameobjects.append(CaveSpider2(1200,750))
        self.gameobjects.append(CaveSpider2(1250,750))
        
        self.gameobjects.append(Skeleton1(1250,750))
                
        # NOTE !! set items after because they collid ewit hfighting
        self.gameobjects.append(HealingPotion(50,500))
        self.gameobjects.append(HealingPotion(1850,880))
        self.gameobjects.append(Dungeonkey1(3000,80))
        self.gameobjects.append(Dungeondoor1(3705,1275,50,50))

        self.gameobjects.append(GhostCircling(1100,950,1100,950))
##               
##        # left NOTE!!! : boxes collide so put them after enemies !
        ####### upper 
        self.gameobjects.append(Box(0,330,750+715,12))
        self.gameobjects.append(Box(750+785,330,365,12))
        self.gameobjects.append(Box(750+1000,330,450,12))
        self.gameobjects.append(Box(2250,330,1700,12))
        # upperest platform
        self.gameobjects.append(Box(2790,170,400,12))
        # upper left room wall
        ### FIXME self.gameobjects.append(Box(1750,0,12,320))
        # outer right room wall
        ### FIXME self.gameobjects.append(Box(3980,0,12,4000))
        # roof
        #### FIXME self.gameobjects.append(Box(0,0,12,2200))
        # ropes
        self.ropes.append(Rope(2780,90,200))
        self.ropes.append(Rope(750+720,0,520))
        ####### lower 2
        self.gameobjects.append(Box(0,580,200,12))
        self.gameobjects.append(Box(700,580,765,12))
        ### FIXME BELOW self.gameobjects.append(Box(1585,580,2330,12))
        self.gameobjects.append(Box(1585,580,2330,12))
        #### self.gameobjects.append(Box(750+785+50+590+50,580,1655,12))
        # ropes
        self.ropes.append(Rope(2210,200,520))
        ####### lower 3
        self.gameobjects.append(Box(0,760,2150,12))
        self.gameobjects.append(Box(2300,760,1075,12))
        # ropes
        self.ropes.append(Rope(3400,720,520))
        ####### lower 4
        self.gameobjects.append(Box(1750,955,320,12))
        self.gameobjects.append(Box(2050,1005,1325,12))
        ### lower 4 short wall
        ### FIXME self.gameobjects.append(Box(1980,935,50,70))
        # wall (corner)
        ### FIXME self.gameobjects.append(Box(1750,800,50,200))

        ####### lower 5
        self.gameobjects.append(Box(1100,1190,1440,12))
        ####### lower 5 wall + corner + rope
        ### FIXME self.gameobjects.append(Box(900,800,24,200))
        self.gameobjects.append(Box(900,1040,300,12))
        self.ropes.append(Rope(1150,900,260))
        ####### lower 6 # lowest platform
        self.gameobjects.append(Box(2550,1360,1450,12))
        # ropes
        self.ropes.append(Rope(2560,1050,320))
        # floor under rope
        # moving platforms
        self.movingplatforms.append(Movingplatform(200,550,100,42,200,670))
        self.movingplatforms.append(Movingplatform2(3900,1150,100,42,500,1320)) 

        self.locationtext = "Nether Mountains"

    def draw(self,screen,player,taskbar):
        sleep(0.02) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.movingplatforms:
            if i != None:
                i.update(self,player)
                i.draw(screen,self,player)
                
                
    def isroomdoorexitleft(self,game):
	if self.relativex  > 180-750 and self.relativex < 250-750 and self.relativey >= -20:
		self.setxyfromdoorleft(game)
		return 1
	return 0

    def setxyfromdoorleft(self,game):
        game.setxy(-1720, 0)

    def isroomdoorexit(self,game):
	if self.relativex  < -720 and self.relativex > - 820 and self.relativey < -590 and self.relativey > -690:
		return 1
	return 0

    def setxyfromdoor(self,game):
        game.x = 250
        game.y = -10

    def isroomdoorholdexit(self,game):
        if game.room.inventorykey1:
        	if self.relativex  < -3320 and self.relativex > -3460 and self.relativey < -970 and self.relativey > -1060:
                    return 1
	return 0

    def setxyfromdoorhold(self,game):
        game.x = 0
        game.y = 0


    def exit(self, game):
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 1
	###if self.isroomdoorexit(game):
	###	self.setxyfromdoor(game)
	###	return 2.2 
	if self.isroomdoorholdexit(game):
		self.setxyfromdoorhold(game)
		return 2.3
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
        return None
##          print "talk to in maproom 2_1"
##            ## return self.koboldwiz
##            self.roadsign.talkcounter = 1
##            return self.roadsign
