
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from tilebox import *
from rope import *
from bow1 import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from scorpionred1 import *
from scorpionred2 import *
from skeleton1 import *
from fishman1 import *

from roadsign import *

class Maproom2_2(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg2-850x600.bmp").convert()
        ###self.northwall1 = Tilebox(1,1,60,48,16,1,'./pics/walldungeonnorth2-beholderglass-60x48.bmp')
##        self.northwall1 = Tilebox(1,1,60,48,13,1,'./pics/walldungeonnorth1-60x48.bmp')
##        self.southwall1 = Tilebox(1,200,30,48,13,1,'./pics/walldungeonsouth1-30x48.bmp')
##        self.westwall1 = Tilebox(360,200,48,60,1,10,'./pics/walldungeonwest1-48x60.bmp')
##        self.eastwall1 = Tilebox(775,1,48,60,1,14,'./pics/walldungeoneast1-48x60.bmp')
##        self.tileboxes.append(self.northwall1)
##        self.tileboxes.append(self.westwall1)
##        self.tileboxes.append(self.eastwall1)
##        self.tileboxes.append(self.southwall1)

        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
        #self.gameobjects.append(Skeleton1(700,315))
        #self.gameobjects.append(Skeleton1(2000,315))
        self.h = -600
        # FIXME1 do not collide with other enemies for boxes
	self.gameobjects.append(Fishman1(300,400-72))
	self.gameobjects.append(Fishman1(400,400-72))
	self.gameobjects.append(Fishman1(500,400-72))


        self.gameobjects.append(Bow1(800,280))
        
        # left NOTE!!! : boxes collide so put them after enemies !
        self.gameobjects.append(Box(0,375,260,12))
        self.gameobjects.append(Box(310,375,130,12))
        self.gameobjects.append(Box(450,375,440,12))


        # left wall
        self.gameobjects.append(Box(0,0,12,480))
        # right wall
        self.gameobjects.append(Box(960,0,12,480))

        # ropes       
        #self.ropes.append(Rope(980,455,140))
        # floor under rope
                
        self.locationtext = "Luruar - Beneath Nether Mountains - somewhere in a sewer"

    def draw(self,screen,player,taskbar):
        sleep(0.05) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
		
    def setxyfromdoorleft(self,game):
        game.x = -3350
	game.y = -1000

    def isroomdoorexitleft(self,game):
        print "foo %s" % self.relativex
	if self.relativex > 220:
		return 1
	return 0

    def setxyfromdoorentranceleft(self,game):
        game.x = -600
        game.y = 40

    def exit(self, game):
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 2.1
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
          return None
