
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from movingplatform import *
from movingplatform2 import *
from roof import *
from maproom import *
from healingpotion import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from feyrismallcircling import *
from feyrimediumcircling import *
from fiendred1 import *
from tilebox import *
from rope import *
from bow1 import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from giganticspiderboss import *
from abeille import *
from abeille2 import *
from bullfrog import *
from scorpionred1 import *
from scorpionred2 import *
from skeleton1 import *
from fishman1 import *

from roadsign import *

class Maproom2_3(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y,game):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg2.3-1850x4000.bmp").convert()
        self.movingbackground = None ### pygame.image.load('./pics/bg1-moving-6000x100.bmp').convert()
        self.movbgrelativey = -460 
	self.inventoryspidereye1 = 0
        self.giganticspiderboss1 = pygame.image.load("./pics/archgohma1.bmp").convert()
	self.giganticspiderboss1.set_colorkey((0,0,0))
        self.giganticspiderboss2 = pygame.image.load("./pics/archgohma2.bmp").convert()
	self.giganticspiderboss2.set_colorkey((0,0,0))
        self.giganticspiderboss3 = pygame.image.load("./pics/archgohma3.bmp").convert()
	self.giganticspiderboss3.set_colorkey((0,0,0))
        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
        #self.gameobjects.append(Skeleton1(700,315))
        #self.gameobjects.append(Skeleton1(2000,315))
        self.h = -4000
        # FIXME1 do not collide with other enemies for boxes
	#self.gameobjects.append(Fishman1(300,400-72))
	#self.gameobjects.append(Fishman1(400,400-72))
	#self.gameobjects.append(Fishman1(500,400-72))
        self.gameobjects.append(FeyriSmallCircling(1800,500,150,500))

        self.gameobjects.append(FeyriSmallCircling(1800,500,1650,300))
        ###self.gameobjects.append(FeyriSmallCircling(1800,500,1750,400))
        ###self.gameobjects.append(FeyriSmallCircling(1800,500,1850,500))

	self.gameobjects.append(FiendRed1(500,700))
	self.gameobjects.append(FiendRed1(700,700))
	self.gameobjects.append(FiendRed1(1700,700))
	self.gameobjects.append(FiendRed1(1600,700))

	self.gameobjects.append(FiendRed1(200,1300))
	self.gameobjects.append(FiendRed1(600,1300))
	self.gameobjects.append(FiendRed1(1700,1300))
	self.gameobjects.append(FiendRed1(1600,1300))

	# potions
        self.gameobjects.append(HealingPotion(50,515))

       	self.gameobjects.append(Box(0,300+72,1850,12))
	self.roofs.append(Roof(0,300+72,1850,12))
        # left wall
        #self.gameobjects.append(Box(0,0,12,480))
        # right wall
        #self.gameobjects.append(Box(960,0,12,480))
	# middle platforms
        self.gameobjects.append(Box(720,680+72,180,12))
        self.gameobjects.append(Box(0,787,1750,12))

        self.gameobjects.append(Box(190,700,200,12))
        self.gameobjects.append(Box(0,580,200,12))
        self.movingplatforms.append(Movingplatform2(1750,747,100,42,747,1270)) 

        self.gameobjects.append(Box(0,1320,1850,12))
	# roofs

	
        # ropes       
        #self.ropes.append(Rope(980,455,140))
        # floor under rope
                
        self.locationtext = "Luruar - Beneath Nether Mountains"
	### leave away because of setting in chooseroom self.bossflag1 = 0 

	### test
	#self.relativex = -550 
	#self.relativey = -400

	self.spidereye = 0
	self.bossflag1 = 0

	# FIXME Debug
	if not game.spidereye and game.bossflag1 == -1:
	    self.gameobjects.append(SpiderEye(600-46,290))	
		
	if game.bossflag1 == 0:
		self.bossflag1 = 0
		self.initspiderboss(game.screen,game.player,game.taskbar)
	elif game.bossflag1 == -1:
		self.bossflag1 = -1
	elif game.bossflag1 <= 3:
		self.bossflag1 = 3
		self.initspiderboss(game.screen,game.player,game.taskbar)
	else:
       		self.gameobjects.append(GiganticSpiderBoss(400-46,190))
		

    def initspiderboss(self,screen,player,taskbar):
	while self.bossflag1 <= 3:#NOTE
        	for event in pygame.event.get():
                	if event.type == QUIT:
                        	self.bossflag1 = 3
                        	return
        	screen.blit(self.background, (0+self.relativex, 0+self.relativey))
		if self.movingbackground:
        		screen.blit(self.movingbackground, (0+self.relativex, 0+self.relativey+self.movbgrelativey))
		if self.bossflag1 == 0:
			screen.blit(self.giganticspiderboss1, (400+46+self.relativex, 190+self.relativey))
		elif self.bossflag1 == 1:
			screen.blit(self.giganticspiderboss2, (400+self.relativex, 190+self.relativey))
		elif self.bossflag1 == 2:
			screen.blit(self.giganticspiderboss3, (400+self.relativex, 190+self.relativey))
		elif self.bossflag1 > 2:
        		self.gameobjects.append(GiganticSpiderBoss(400-46,190))
        		# left NOTE!!! : boxes collide so put them after enemies !
			self.ngos = len(self.gameobjects)
			self.bossflag1 +=1
			break	
                taskbar.draw0("Gigantic Spider Boss")
                player.draw(screen)
		pygame.display.update()
       		sleep(1.0)
		self.bossflag1 +=1


    def draw(self,screen,player,taskbar):
        sleep(0.05) # FIXME in each room

        # draw bg
	print "bgx=%d bgy=%d" % (self.relativex, self.relativey)
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.movingplatforms:
            if i != None:
                i.update(self,player)
                i.draw(screen,self,player)
                
		
    def setxyfromdoorleft(self,game):
        game.x = -3350
	game.y = -1000

    def setxyfromdoorright(self,game):
        game.x = -700
	game.y = -700

    def isroomdoorexitleft(self,game):
	if self.relativex > 0 and self.relativex < 40:
		return 1
	return 0

    def setxyfromdoorentranceleft(self,game):
        game.x = -600
        game.y = 40

    def isroomdoorexitright(self,game):
	if self.relativex < -1410 and self.relativey >= -10:
		return 1
	return 0

    def isroomdoorexitmiddle(self,game):
	if self.relativex > -570 and self.relativex < -510:
		return 1
	return 0

    def isroomdoorexitmiddlecave(self,game):
	if self.relativex > -670 and self.relativex < -600 and self.relativey < -900:
		return 1
	return 0

    def exit(self, game):
	if self.spidereye == 1:
		game.spidereye = 1	
	if self.bossflag1 >= 3:
		game.bossflag1 = 1
	if self.bossflag1 == -1:
		game.bossflag1 = -1
	if self.isroomdoorexitmiddlecave(game):
		game.x = 0
		game.y = -180
		return 2.4 # stay in same room
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 2.1
	if self.isroomdoorexitright(game):
		#### self.setxyfromdoorright(game)
		self.relativex = -550
		self.relativey = -400
		self.movingbackground = None
		return 0 # stay in same room
	if self.isroomdoorexitmiddle(game):
		self.relativex = -1415
		self.relativey = 0
		return 0 # stay in same room
		
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
          return None
