
# Copyright (C) Johan Ceuppens 2014
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from deepgnome1 import *
from deepgnomeillusionist1 import *
from koboldwizard1 import *
from abeilleenemy1 import *
from abeillequeenenemy import *
from movingplatform import *
from movingplatform2 import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from ghostwandering import *
from ghostwanderingplatform import *
from cavebat1 import *
from cavebat2 import *
from cavebat3 import *
from cavebat4 import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from demon import *
from demonpriest import *
from beholder import *
from gauth import *
from overseer import *
from demonpigflying import *
from tilebox import *
from healingpotion import *
from manapotion import *
from scrollmagicmissile1 import *
from rope import *
from roof import *
from bow1 import *
#from snake1 import *
from rubysword import *
from beholder import *
from beholderbat import *
from abeille import *
from abeille2 import *
from bullfrog import *
from spider1 import *
from hobgoblin1 import *
from hobgoblinactivated1 import *
from scorpionred1 import *
from scorpionredplatform1 import *
from scorpionred2 import *
from skeleton1 import *
from fishman1 import *

from priestspellscurelightwounds import *
from priestspellscurelightwoundssehaninemoonbow import *
from roadsign import *

class Maproom2_4(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y, game):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load("./pics/bg2.4-3200x3000.png").convert()
        # left NOTE!!! : boxes collide so put them after enemies and roadsigns !
	### self.gameobjects.append(DeepGnome1(800,480))
	### self.gameobjects.append(DeepGnomeIllusionist1(800,480,game))
	### self.gameobjects.append(KoboldWizard1(700,480,game))
	### self.gameobjects.append(AbeilleEnemy1(800,480))
	### self.gameobjects.append(AbeilleQueenEnemy(700,480,game))

        #self.gameobjects.append(Skeleton1(700,315))
        #self.gameobjects.append(Skeleton1(2000,315))
        self.h = -3000
        # FIXME1 do not collide with other enemies for boxes
	#self.gameobjects.append(Fishman1(300,400-72))
	#self.gameobjects.append(Fishman1(400,400-72))
	#self.gameobjects.append(Fishman1(500,400-72))
	#self.gameobjects.append(Hobgoblin1(400,50))

	self.gameobjects.append(Spider1(400,500))
	self.gameobjects.append(Spider1(700,500))
	self.gameobjects.append(Spider1(800,500))

	self.gameobjects.append(GhostWanderingPlatform(300,45,100,500))
	self.gameobjects.append(Gauth(1450,0,game))

	### self.gameobjects.append(Overseer(1450,0,game))
	### self.gameobjects.append(DemonPriest(1450,400,game))
	### self.gameobjects.append(ScorpionRedPlatform1(330,50,330,480))

	self.gameobjects.append(CaveBat4(1950,700))
	self.gameobjects.append(CaveBat4(2000,700))
	self.gameobjects.append(CaveBat4(2050,700))

	self.gameobjects.append(CaveBat4(2400,700))
	self.gameobjects.append(CaveBat4(2450,700))
	self.gameobjects.append(CaveBat4(2500,700))

	self.gameobjects.append(HobgoblinActivated1(2600,400,2600,0))
	self.gameobjects.append(HobgoblinActivated1(2700,400,2700,0))
	self.gameobjects.append(HobgoblinActivated1(2750,400,2750,0))

	self.gameobjects.append(ScrollMagicMissile1(330,50))

	self.gameobjects.append(ManaPotion(1000-40,480))
	self.gameobjects.append(HealingPotion(1000,480))

        # left NOTE!!! : boxes collide so put them after enemies !
        self.gameobjects.append(Box(0,550,1750,12))
        ### self.roofs.append(Roof(0,0,3200,12))

	# platforms with scrolls on the left
        self.gameobjects.append(Box(450,400,130,12))
        self.roofs.append(Roof(450,400,130,12))
        self.gameobjects.append(Box(500,400,12,200))

        self.gameobjects.append(Box(100,280,480,12))
        self.roofs.append(Roof(100,280,480,12))

	self.ropes.append(Rope(580, 180, 200))

        self.gameobjects.append(Box(325,100,165,12))
        self.roofs.append(Roof(325,100,165,12))

	self.ropes.append(Rope(485, 50, 210))

	# platforms as stairs up to the right
        self.gameobjects.append(Box(620,340,120,12))
        self.roofs.append(Roof(620,340,120,12))

        self.gameobjects.append(Box(750,280,130,12))
        self.roofs.append(Roof(750,280,130,12))

        self.gameobjects.append(Box(890,200,180,12))
        self.roofs.append(Roof(890,200,180,12))

	# hidden platform stuff
	self.gameobjects.append(Box(1080,100,320,80))
	self.gameobjects.append(Box(1430,100,180,80))

	self.gameobjects.append(Box(1080,180,120,140))
	self.gameobjects.append(Box(1080,320,670,55))

	self.roofs.append(Roof(1080,320,430,55))
	self.ropes.append(Rope(1390, 20, 260))
	
	self.gameobjects.append(Box(1430,180,180,220))

	# right side of above
	self.gameobjects.append(Box(1700,320,50,200))
	# hole in floor	
        self.gameobjects.append(Box(1850,550,1350,12))
	self.movingplatforms.append(Movingplatform2(1770,500,100,42,500,850))

	# lower 1
        self.gameobjects.append(Box(1375,500,375,250))
        self.gameobjects.append(Box(1850,500,600,200))
        self.roofs.append(Roof(1850,500,600,12))
	
	# lower 1 down
        self.gameobjects.append(Box(1750,860,1150,80))
        self.roofs.append(Roof(1750,860,1150,80))

	# lower 1 down to the right (uppish platform isolated)
        self.gameobjects.append(Box(2830,700,70,160))
        ### self.gameobjects.append(Box(2830,700,70,160))
        self.gameobjects.append(Box(2730,650,250,50))
	self.ropes.append(Rope(2740,575,310))

	# lower most on the right
        self.gameobjects.append(Box(3160,500,40,600))
        self.gameobjects.append(Box(3000,860,200,80))
        self.roofs.append(Roof(3000,860,200,80))
	# lower 2
        self.gameobjects.append(Box(2500,1030,800,40))
        self.roofs.append(Roof(2500,1030,800,40))
	
	# lower 2 left 
        self.gameobjects.append(Box(2050,920,40,130))
        self.gameobjects.append(Box(2050,1140,330,40))
        self.roofs.append(Roof(2050,1140,330,40))
	
	# lower 3 (2 single platforms)
        self.gameobjects.append(Box(2500,1200,400,40))
        self.roofs.append(Roof(2500,1200,400,40))
        self.gameobjects.append(Box(2900,1200,300,40))
        self.roofs.append(Roof(2900,1200,300,40))
	
	# middle rope
	self.ropes.append(Rope(2450,940,450))

	# lower 4
        self.gameobjects.append(Box(2450,1400,450,40))
        self.roofs.append(Roof(2450,1400,450,40))
        self.gameobjects.append(Box(2900,1400,300,40))
        self.roofs.append(Roof(2900,1400,300,40))
	
	# lower 5
        self.gameobjects.append(Box(1775,1650,1425,40))
        self.roofs.append(Roof(1775,1650,1425,40))
	self.ropes.append(Rope(2900,1100,500))

	# lower 5 to the left
	self.gameobjects.append(Box(1750,1400,50,300))
	self.gameobjects.append(Box(1450,1450,350,40))
	self.roofs.append(Roof(1450,1450,350,40))
	self.gameobjects.append(Box(1450,1490,80,500))

	self.ropes.append(Rope(1850,1300,350))
	
	# passage to the left platform 
	self.gameobjects.append(Box(1450,1740,250,12))
	self.roofs.append(Roof(1450,1740,250,12))

	# lower 5 to the left of box
	self.gameobjects.append(Box(1100,1550,450,12))
	self.roofs.append(Roof(1100,1550,450,12))

	# lower 5 left of left	
	self.gameobjects.append(Box(650,1800,600,12))
	self.roofs.append(Roof(650,1800,600,12))
	self.gameobjects.append(Box(1250,1800,12,100))

	# moving platform
	self.movingplatforms.append(Movingplatform2(1000,1500,100,14,1500,1750))

	# lower 6
	self.gameobjects.append(Box(1250,1925,1625,12))
	
	# lower 6 left towards first passage door
	self.gameobjects.append(Box(800,1000,140,650))	
	self.gameobjects.append(Box(600,1300,140,500))	
	self.gameobjects.append(Box(400,1300,350,12))	

	self.gameobjects.append(Box(0,1000,950,35))	
	self.roofs.append(Roof(0,1000,950,35))	

	# rope towards left passage
	self.ropes.append(Rope(750, 1100, 700))

	# lower 7
	self.gameobjects.append(Box(2680,2050,470,12))
	self.roofs.append(Roof(2680,2050,470,12))

	self.gameobjects.append(Box(2660,2050,60,200))

	self.gameobjects.append(Box(1600,2200,1050,12))
	self.roofs.append(Roof(1600,2200,1050,12))

	# lower 7 block above lower 7
	self.gameobjects.append(Box(1575,1850,875,150))
	self.roofs.append(Roof(1575,2250,875,150))
		
	# lower 7 block on the left of lower 7
	self.gameobjects.append(Box(1575,1850,250,250))
		
	
        # left wall
        self.gameobjects.append(Box(0,0,12,3000))
        # right wall
        self.gameobjects.append(Box(3200,0,12,3000))

                
        self.locationtext = "Luruar - Beneath Nether Mountains"

	# needs to be set for exiting this room towards room 2.3 
	self.spellbookscrollmagicmissile1 = 0

    def draw(self,screen,player,taskbar):
        sleep(0.05) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
	j = 0
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
		if self.godmode:
			i.godattention(player,j)
	    j += 1
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.movingplatforms:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self,player)

    def setxyfromdoorleft(self,game):
        game.x = -620
	game.y = -950

    def isroomdoorexitleft(self,game):
        print "exit relx=%s rely=%s" % (self.relativex,self.relativey)
	if self.relativex > -20 and self.relativex < 30 and self.relativey >= -190:
		return 1
	return 0

    def setxyfromdoordeepgnomevillage(self,game):
        game.x = -620
	game.y = 0

    def isdeepgnomevillageexit(self,game):
        print "exit relx=%s rely=%s" % (self.relativex,self.relativey)
	if self.relativex < -2750 and self.relativex > -2810 and self.relativey > -700 and self.relativey < -500:
		return 1
	return 0

    def isfirstpassageexitleft(self,game):
        print "exit relx=%s rely=%s" % (self.relativex,self.relativey)
	if self.relativex > -200 and self.relativex < -120 and self.relativey > -1000 and self.relativey < -900:
		return 1
	return 0

    def isfirstpassageexitright(self,game):
        print "exit relx=%s rely=%s" % (self.relativex,self.relativey)
	if self.relativex < -1330 and self.relativex > -1430 and self.relativey < -1320 and self.relativey > -1420:
		return 1
	return 0

    def exit(self, game):
	print "*** calling exit from room 2.4"
	if self.isroomdoorexitleft(game):
		self.setxyfromdoorleft(game)
		return 2.3
	elif self.isdeepgnomevillageexit(game):
		self.setxyfromdoordeepgnomevillage(game)
		return 2.5
	elif self.isfirstpassageexitleft(game):
		self.relativex = -1380
		self.relativey = -1320
	elif self.isfirstpassageexitright(game):
		self.relativex = -160
		self.relativey = -940
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
          return None
