
# Copyright (C) Johan Ceuppens 2014
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from hobgoblinfalling1 import *
from deepgnome1 import *
from goblin1 import *
from goblin2 import *
from goblin4 import *
from goblin3 import *
from tilebox import *
from rope import *
#from snake1 import *
from rubysword import *
from fishman1 import *
from beholder import *
from beholderbat import *
from beholderbatswooping import *
from abeille import *
from abeille2 import *
from bullfrog import *
from bullfrog2 import *
from bullfrog3 import *
from bullfrog4 import *
from bullfrog5 import *
from scorpionred1 import *
from scorpionred2 import *
from scorpionred3 import *
from scorpionred4 import *
from spider1 import *
from spider2 import *
from cavespider1 import *
from skeleton1 import *
from nethermountainsroadsign import *
from xammuxroadsign import *
from kibiraroadsign import *
from ghostwandering import *
from ghostcircling import *
from ghostcircling2 import *
from feyrismallcircling import *
from feyrimediumcircling import *

class MaproomVillage1(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y):
        MaproomDungeon.__init__(self,x,y)
	self.w = -1400
	self.h = -600
        self.background = pygame.image.load('./pics/bg2.5-village1-1400x504.png').convert()
        self.movingbackground = None ### pygame.image.load('./pics/bg1-moving-6000x100.bmp').convert()
        self.movbgrelativey = -560 

        # left NOTE!!! : boxes collide so put them after enemies !
        self.roadsign = KibiraRoadSign(920,310)#FIXME 540
        self.gameobjects.append(self.roadsign)

        ##self.gameobjects.append(Bullfrog(700,320))
        ##self.gameobjects.append(Bullfrog(1800,320))
        ##self.gameobjects.append(Bullfrog(1500,320))
        ##self.gameobjects.append(Bullfrog5(170,270,500))
        ##self.gameobjects.append(Bullfrog4(100,0,700))
       
	self.gameobjects.append(Box(0,400,1400,12))


	self.gameobjects.append(DeepGnome1(700,400-48))
 
        self.locationtext = "Kibira - Underground Village"
        
    def draw(self,screen,player,taskbar):
	print "mapx=%d mapy=%d" % (self.relativex, self.relativey)
        sleep(0.05) # FIXME in each room
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	for i in self.ropes:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
		
    def isexitright(self,game):
	if self.relativex  < -770:
		return 1
	return 0

    def setxyright(self,game):
        game.x = -2750 
        game.y = -500

    def exit(self, game):
	if self.isexitright(game):
		self.setxyright(game)
		return 2.4 
	return 0 
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None

    def talkto(self):#FIXME needs font
            print "talk to in maproom 1"
            ## return self.koboldwiz
            self.roadsign.talkcounter = 1
            return self.roadsign
