
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
# A large version of beholder and looks like a flesh tree
# 

import pygame
from pygame.locals import *
from gameobject import *
from gameobjectmagicuser import *
from stateimagelibrary import *
import random
from rng import *
from time import *
from strength import *
from dexterity import *
from necromancerspelldictionaryenemy import *
from beholderspelldictionaryenemy1 import *
from gauthspelldictionaryenemy1 import *
from overseerspelldictionaryenemy1 import *

from beholder import *

class Overseer(Beholder):
    "Overseer Beholder"
    def __init__(self,xx,yy,game):
	Gameobject.__init__(self, xx, yy)
	Beholder.__init__(self, xx,yy, self.rng, self.rng.rolld10()+50, ["Magic Missile 1", "Shocking Grasp", "Vampiric Touch"], OverseerSpellDictionaryEnemy1(game, self), game)

	self.stimlib = Stateimagelibrary()	
	self.stimlibup = Stateimagelibrary()	
        image = pygame.image.load('./pics/overseer1-300x332.bmp').convert()
        image.set_colorkey((255,255,255)) 
	self.stimlib.addpicture(image)	
	self.stimlibup.addpicture(image)	
        self.hitpoints = 50 
	self.level = self.rng.rolld10()

	self.strength = Strength(17)
	self.dexterity = Dexterity(18)
        
	self.talkcounter = 0
	self.direction = "left"
	self.w = 300
	self.h = 332

    def update(self,room,player):

	r = self.getrng().rolld30()
	
	if self.annulinvisible == 1:
		self.invisible = 0	
	elif r == 1 and self.annulinvisible == 0:
		if self.invisible == 0:
			# beholder becomes invisible
			self.invisible = 1
		elif self.invisible > 0:
			self.invisible = 0

	if room.collidewithenemy(self):
	    if (self.direction == "right"):
	        self.x -=2
	        self.direction = "left" 
	    elif (self.direction == "left"):
	        self.x +=2
	        self.direction = "right"
	    elif (self.direction == "down"):
	        self.y -=2
	        self.direction = "up" 
	    elif (self.direction == "up"):
	        self.y +=2
	        self.direction = "down"

	if player.x+28-room.relativex < self.x:
		self.x -= 1
		self.direction = "left"
	if player.x-28-room.relativex > self.x:
		self.direction = "right"
		self.x += 1	
	if player.y+10-room.relativey < self.y:
		self.direction = "up"
		self.y -= 1 
	if player.y-10-room.relativey > self.y:
		self.direction = "down"
		self.y += 1

	self.cast(room,player)

    def fight(self,room,player):
        self.fightcounter = 1
        o = player.collidewithenemyweapon(room,self)
        if o:
            player.hitwithenemyweapon(self.getrng().rolloverseerbeholder())
