
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from stateimagelibrary import *
from playerbase import *
from rng import *
from deity import *
from deitycorellonlarethain import *
from deitysehaninemoonbow import *
from overalldeity import *
from broadsword import *
from rubysword import *
from inventorybow1 import *
from priestspellsenhancepower import *
from priestspellscurelightwounds import *
from priestspellscurelightwoundssehaninemoonbow import *
from priestspellsdispelmagic import *
from priestspellsprotectionfromspells import *
from spellbookscrollmagicmissile1 import *
from spellbookscrollmagicmissile2 import *
from spellbookscrollmagicmissile3 import *
from spellbookscrollseeinvisibility import *
from magicnumber import *
from magicmissile1 import *
from magicmissile2 import *
from magicmissile3 import *
from arrow import *
from knife import *
from bow1 import *

class PlayerLink(PlayerBase):
    "Player"
    def __init__(self,heartmeter,xx,yy,race,klass):
        PlayerBase.__init__(self,race,klass,heartmeter)
        self.x = xx
        self.y = yy 
        self.stimlibright = Stateimagelibrary()	
        image = pygame.image.load('./pics/player1-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player3-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)
	image = pygame.image.load('./pics/player2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibright.addpicture(image)

	self.stimlibleft = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerleft1-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft3-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)
	image = pygame.image.load('./pics/playerleft2-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibleft.addpicture(image)

        self.stimlibfight = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerfight1-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibfight.addpicture(image)

        self.stimlibclimbing = Stateimagelibrary()	
        image = pygame.image.load('./pics/player-climbing-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibclimbing.addpicture(image)

        self.stimlibduck = Stateimagelibrary()	
        image = pygame.image.load('./pics/playerduck1-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibduck.addpicture(image)

       	self.weapon = Knife(0,0,0,0,self)

        self.duck = 0
        self.jumpcounter = 0

	# The current level of the player
	self.level = 1
	self.magicuserlevel = 1
	self.priestlevel = 1
	# list of all rngdeity instances (subclasses of Deity)
	self.deities = []
 	# roll approx. d20 and manifest power or grant power in PriestSpells
	# class (p key)
	self.deityrangeofpowerslist = []

	self.currentdomain = None
	self.sehanine = None 
	self.corellon = None 
	self.overalldeity = None

    def godattention(self, enemy, idx):
	for d in self.deities:
		d.attention(enemy, idx)

    def imbibibmanapotion(self):
	l = self.luck.get() % self.rng.rolld10()
	self.manapoints = self.maxmanapoints - l
	if l < 5:
		self.manapoints -= self.rng.rolld10()

    def dream(self, enemy):
	self.strength.set(self.strength.get() - self.rng.rolld2())
	
    def nightmare(self, enemy):
	self.strength.set(self.strength.get() - self.rng.rolld2())
	
    def askpicture(self):
        return './pics/taskbar-PC.bmp'

    def collidewithenemyweapon(self,room,o):
        #FIXME2
        if o.collide(room,self):
		return self ## NOTE : returns collided entity (single)
		
	return None

    def hitwithenemyweapon(self,damage):
	if damage > 0:
		print 'player is hit!'
                self.hitpoints -= damage

    def pickup(self,room):
        n = room.pickup(self)
	return n

    def generatedeityrollslist(self, game):
	# NOTE you can give more deity watching powers with adding to l
	r = self.rng.rolld20()
	l = []
	l.append(r)
	return l
			
    def generatedeitypowerslist(self, game, deity):
	r = self.rng.rolld4()			
	
	if r == 1:
		if game.player.priestlevel == 1:
			self.deityrangeofpowerslist.append(1)	
		if game.player.priestlevel >= 2:
			self.deityrangeofpowerslist.append(2)	
		if game.player.priestlevel >= 3:
			self.deityrangeofpowerslist.append(3)	
		if game.player.priestlevel >= 4:
			self.deityrangeofpowerslist.append(4)	
		if game.player.priestlevel >= 5:
			self.deityrangeofpowerslist.append(5)	
		if game.player.priestlevel >= 6:
			self.deityrangeofpowerslist.append(6)	
		if game.player.priestlevel >= 7:
			self.deityrangeofpowerslist.append(7)	
		if game.player.priestlevel >= 8:
			self.deityrangeofpowerslist.append(8)	
		if game.player.priestlevel >= 9:
			self.deityrangeofpowerslist.append(9)	

	###for k in deity.deitydomainnumbers.keys():
	r = randint(0, len(deity.deitydomainnumbers.keys())-1)
	self.currentdomain = deity.domains[deity.deitydomainnumbers[r]]
	game.setdomain(self.currentdomain)
		

    def deitypower(self,game):
	### deity points which are negative are for evil
	### around zero is a neutral player
	### above zero is a good player

	# generate priest spells as gods come into play
	if self.sehanine == None:
		if self.globaldeitypoints > 100 or self.deityenemydefeatedpoints < -100:
			self.sehanine = DeitySehanineMoonbow(game)
			self.deities.append(self.sehanine)
			self.generatedeitypowerslist(game, self.sehanine)

	if self.corellon == None:
		if self.deityenemydefeatedpoints < -40:
			self.corellon = DeityCorellonLarethain(game)
			self.deities.append(self.corellon)
			self.generatedeitypowerslist(game, self.corellon)	
	
	if self.overalldeity == None:
		self.overalldeity = OverallDeity(game)
						

	rollslist = self.generatedeityrollslist(game)

	# roll d20 to see if deity does something
	for d in self.deities:
		if d:
			d.deitywatches(rollslist, game)	

	###if self.priestpoints <= 0:
	###	return
	for d in self.deities:
		if d:
			priestspellsitem = d.deitygrantrandompriestspellbasedonlevel(game)
			if priestspellsitem:
				flag = 0
				for item in game.priestspells.list:
					if item and item.id == priestspellsitem.id:
						flag = 1

				if flag == 0:		
					game.priestspells.additem(d.deitygrantpriestspell(game))

	### Common priest spell casting, returns statements 

	if game.room.priestspellsitem:
		if game.room.priestspellsitem.maxuse == 1:
			game.priestspells.remove(game.room.priestspellsitem)
			game.room.priestspellsitem = None
			game.taskbar.setpriestspellblank()
			return 
		elif game.room.priestspellsitem.maxuse > 0:
			game.room.priestspellsitem.maxuse -= 1
		elif game.room.priestspellsitem.maxuse == MagicNumber().get():
			1 ### item can always be used based on parameters

        if game.room.priestspellsitem and game.room.priestspellsitem.id == PriestSpellsProtectionFromSpells().id:
		for go in game.room.gameobjects:
			if go and go.type == MagicNumber().get():
				game.room.removeobject(go)	

        elif game.room.priestspellsitem and game.room.priestspellsitem.id == PriestSpellsDispelMagic().id:
		for go in game.room.gameobjects:
			if go and go.type == MagicNumber().get():
				game.room.removeobject(go)	

        elif game.room.priestspellsitem and game.room.priestspellsitem.id == PriestSpellsEnhancePower().id:
		for d in self.deities:
			d.enhancedpowerbydeity += self.rng.rolld2()	

        elif game.room.priestspellsitem and game.room.priestspellsitem.id == PriestSpellsCureLightWoundsSehanineMoonbow().id:
		self.hitpoints += self.rng.rolld10() + 4
		self.hitpoints += self.luck.get() % self.rng.rolld20()
		self.maxhitpoints += self.luck.get() % self.rng.rolld6() 
		if self.hitpoints > self.maxhitpoints:
			self.hitpoints = self.maxhitpoints
		
        elif game.room.priestspellsitem and game.room.priestspellsitem.id == PriestSpellsCureLightWounds().id:
		self.hitpoints += self.rng.rolld10() + 4
		self.hitpoints += self.luck.get() % self.rng.rolld6() 
		if self.hitpoints > self.maxhitpoints:
			self.hitpoints = self.maxhitpoints
		
    def cast(self,game):
	if self.manapoints <= 0:
		return

        if game.room.spellbookitem and game.room.spellbookitem.id == SpellBookScrollMagicMissile1().id:
	    self.manapoints -= SpellBookScrollMagicMissile1().manapoints
            o = game.room.collidebow(self)
	    if o:
		if self.x-game.room.relativex < o.x: 
			game.room.gameobjects.append(MagicMissile1(self.x+self.w+10-game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		else:
			game.room.gameobjects.append(MagicMissile1(self.x-10+game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		print "fight scored hit on %s scroll magic missile1!" % o
		o.hitwithweapon(self.rng.rollmagicmissile1())
        elif game.room.spellbookitem and game.room.spellbookitem.id == SpellBookScrollMagicMissile2().id:
	    self.manapoints -= SpellBookScrollMagicMissile2().manapoints
            o = game.room.collidebow(self)
	    if o:
		if self.x-game.room.relativex < o.x: 
			game.room.gameobjects.append(MagicMissile2(self.x+self.w+10-game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		else:
			game.room.gameobjects.append(MagicMissile2(self.x-10+game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		print "fight scored hit on %s scroll magic missile2!" % o
		o.hitwithweapon(self.rng.rollmagicmissile2())
        elif game.room.spellbookitem and game.room.spellbookitem.id == SpellBookScrollMagicMissile3().id:
	    self.manapoints -= SpellBookScrollMagicMissile3().manapoints
            o = game.room.collidebow(self)
	    if o:
		if self.x-game.room.relativex < o.x: 
			game.room.gameobjects.append(MagicMissile3(self.x+self.w+10-game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		else:
			game.room.gameobjects.append(MagicMissile3(self.x-10+game.room.relativex,self.y+self.h/2+game.room.relativey,o.x,o.y,self))
		print "fight scored hit on %s scroll magic missile3!" % o
		o.hitwithweapon(self.rng.rollmagicmissile3())
        elif game.room.spellbookitem and game.room.spellbookitem.id == SpellBookScrollseeinvisibility().id:
	    self.manapoints -= SpellBookScrollMagicMissile3().manapoints
	    for e in game.room.gameobjects:
		if e:
			e.annulinvisible = 1

    def fight(self,room,game,player):
        self.fightcounter = 1

        if game.room.inventoryitem and game.room.inventoryitem.id == Inventorybow1().id:
            o = room.collidebow(self)
	    if o:
		if player.x-room.relativex < o.x: 
			room.gameobjects.append(Arrow(player.x+player.w+10-room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		else:
			room.gameobjects.append(Arrow(player.x-10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		print "fight scored hit on %s bow!" % o
		o.hitwithweapon(self.rng.rollbow())
        else:
            #o = room.collidesword(self)
            o = room.collideknife(self)
            if o:
                if player.x-room.relativex < o.x:# and abs(player.y+room.relativey-o.y) <= 30:
			room.gameobjects.append(Knife(player.x+player.w+10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
		else:
			room.gameobjects.append(Knife(player.x-10+room.relativex,player.y+player.h/2+room.relativey,o.x,o.y,self))
      
                print "fight scored hit on %s knife!" % o
                o.hitwithweapon(self.rng.rollthrowknife())

    def jump(self, room):
        self.jumpcounter = 33
        ##FIXME1 self.direction = 'north'

    def update(self,room):
       if self.jumpcounter > 0 and self.jumpcounter < 140:
	    for r in room.roofs:
		if r.collide(room, self):
			self.jumpcounter = 140
            		###FIXMEroom.relativey -= 45 
            		room.relativey -= 34 
			return
            room.relativey += 33
            self.jumpcounter += 15
       else:   
            self.jumpcounter = 0
            
    def setrubysword(self):
	self.weapon = RubySword(0,0)

    def setbow(self):
	self.weapon = Bow1(0,0)


    def talk(self, game):
	for t in game.room.gameobjects:
		if t != None and t.collidetalk(game.room, game.player) == 1:
			t.talk(game)
	return None


    def enemykilledon(self, enemy):
	if enemy.type < 0:
		self.deityenemydefeatedpoints += enemy.type
	elif enemy.type > 0:
		self.deityenemydefeatedpoints += enemy.type
	else:
		return
