
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from time import *

class RoadSign(Gameobject):
    ""
    def __init__(self,xx,yy):
	Gameobject.__init__(self, xx, yy)
        self.w = 50
        self.h = 50 
        self.image = pygame.image.load('./pics/roadsign1-36x36.bmp').convert()
        self.image.set_colorkey((0,0,0)) 
        self.talkcounter = 0
        self.hitpoints = 3000 # FIXME destroy roadsign
        
    def draw(self, screen, room):
        screen.blit(self.image, (self.x+room.relativex,self.y+room.relativey))
	    
	     
    def update(self,room,player):
        1

    def collide(self, room, player):
        # FIXME NOTE : collision is different
        #print 'gameobject x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y-room.relativey)
	if (player.x-room.relativex >= self.x-self.w  and 
	player.x-room.relativex <= self.x+self.w+self.w and 
	player.y-room.relativey >= self.y and#-self.h and 
	player.y-room.relativey <= self.y + self.h):
	    print "collision with Roadsign!"
	    return 2
	else:
	    return 0
	
    def talk(self, screen,font):
        if self.talkcounter == 0:
            return
        
        if self.talkcounter > 1:
                self.talkcounter = 0
                return 
        talkover = 0
        while talkover == 0:
            pygame.display.update()
            if self.talkcounter == 1:
                screen.blit(font.render("<- Dragonback Mountains - Elf Village ->", 6, (255,255,255)), (100,100))
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_z or event.key == K_x:
                        talkover = 1
                        self.talkcounter += 1
                
